#include <stdbool.h>
#include <string.h>
#include "misc.h"

/*
insert node into p at the end if data is not contained between p and end
*/
listNode* uniqueInsert(listNode *p,char *sNewData)
{
	while(p->next!=NULL)//find last node and verify new data is unique
	{
		p=p->next;
		if(strcmp(sNewData,p->sData)==0)
		{
			return NULL;
		}
	}
	p->next=(listNode*)malloc(sizeof(listNode));
	p=p->next;
	p->sData=strdup(sNewData);
	p->next=NULL;
	return p;
}
/*
destruct a list from p to end
*/
void destructList(listNode *p)
{
	while(p!=NULL)
	{
		listNode *next=p->next;
		if(p->sData!=NULL)
		{
			memset(p->sData,0,sizeof(p->sData));//overwrite memory for safety
			free(p->sData);
		}
		free(p);
		p=next;
	}
}
